QwtSplineCubic(3)

NAME
QwtSplineCubic - A cubic spline.

SYNOPSIS

#include <qwt_spline_cubic.h>

Inherits QwtSplineC2.

  Public Member Functions
QwtSplineCubic ()
Constructor The default setting is a non closing natural spline with no parametrization.
virtual ~QwtSplineCubic ()
Destructor.
virtual uint locality () const override
virtual QPainterPath painterPath (const QPolygonF &) const override
Interpolate a curve with Bezier curves.
virtual QVector< QLineF > bezierControlLines (const QPolygonF &points) const override
Interpolate a curve with Bezier curves.
virtual QVector< QwtSplinePolynomial > polynomials (const QPolygonF &) const override
Calculate the interpolating polynomials for a non parametric spline.
virtual QVector< double > slopes (const QPolygonF &) const override
Find the first derivative at the control points.
virtual QVector< double > curvatures (const QPolygonF &) const override
Find the second derivative at the control points.

  Additional Inherited Members

Detailed Description

A cubic spline. A cubic spline is a spline with C2 continuity at all control points. It is a non local spline, what means that all polynomials are changing when one control point has changed.

The implementation is based on the fact, that the continuity condition means an equation with 3 unknowns for 3 adjacent points. The equation system can be resolved by defining start/end conditions, that allow substituting of one of the unknowns for the start/end equations.

Resolving the equation system is a 2 pass algorithm, requiring more CPU costs than all other implemented type of splines.

Definition at line 33 of file qwt_spline_cubic.h.

Member Function Documentation

  QVector< QLineF > QwtSplineCubic::bezierControlLines (const QPolygonF & points) const [override], [virtual]

Interpolate a curve with Bezier curves. Interpolates a polygon piecewise with cubic Bezier curves and returns the 2 control points of each curve as QLineF.

Parameters
    points Control points

Returns
    Control points of the interpolating Bezier curves

Note
    The implementation simply calls QwtSplineC1::bezierControlLines()

Reimplemented from QwtSplineC2.

Definition at line 1149 of file qwt_spline_cubic.cpp.

  QVector< double > QwtSplineCubic::curvatures (const QPolygonF & points) const [override], [virtual]

Find the second derivative at the control points.

Parameters
    points Control nodes of the spline

Returns
    Vector with the values of the 2nd derivate at the control points

See also
    slopes()

Note
    The x coordinates need to be increasing or decreasing

Implements QwtSplineC2.

Definition at line 1078 of file qwt_spline_cubic.cpp.

  uint QwtSplineCubic::locality () const [override], [virtual]
A cubic spline is non local, where changing one point has em effect on all polynomials.

Returns
    0

Reimplemented from QwtSpline.

Definition at line 989 of file qwt_spline_cubic.cpp.

  QPainterPath QwtSplineCubic::painterPath (const QPolygonF & points) const [override], [virtual]

Interpolate a curve with Bezier curves. Interpolates a polygon piecewise with cubic Bezier curves and returns them as QPainterPath.

Parameters
    points Control points

Returns
    Painter path, that can be rendered by QPainter

Note
    The implementation simply calls QwtSplineC1::painterPath()

Reimplemented from QwtSplineC2.

Definition at line 1130 of file qwt_spline_cubic.cpp.

  QVector< QwtSplinePolynomial > QwtSplineCubic::polynomials (const QPolygonF & points) const [override], [virtual]

Calculate the interpolating polynomials for a non parametric spline.

Parameters
    points Control points

Returns
    Interpolating polynomials

Note
    The x coordinates need to be increasing or decreasing

    The implementation simply calls QwtSplineC2::polynomials(), but is intended to be replaced by a one pass calculation some day.

Reimplemented from QwtSplineC2.

Definition at line 1167 of file qwt_spline_cubic.cpp.

  QVector< double > QwtSplineCubic::slopes (const QPolygonF & points) const [override], [virtual]

Find the first derivative at the control points. In opposite to the implementation QwtSplineC2::slopes the first derivates are calculated directly, without calculating the second derivates first.

Parameters
    points Control nodes of the spline

Returns
    Vector with the values of the 2nd derivate at the control points

See also
    curvatures(), QwtSplinePolynomial::fromCurvatures()

Note
    The x coordinates need to be increasing or decreasing

Reimplemented from QwtSplineC2.

Definition at line 1006 of file qwt_spline_cubic.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.